{
prog: Strip .PL5 file to an .INC file..
code: d-fader
date: april 30, 1999
cmnt: nah..

(C) 1999 TeddyWareZ

}

uses crt, TwZ;

var
  pl5_data : array[0..255] of byte;
  f1       : file;
  f2       : text;
  result   : word;

  count1   : byte;
  count2   : byte;

BEGIN
  if paramstr(1) = '' then
    begin
      writeln ('Usage: GETPL5 <source file name>');
      writeln;
      writeln ('Output file is input file with .INC extension..');
      halt (255);
    end;

  assign (f1, paramstr(1));
  {$I-}
  reset (f1, 1);
  {$I+}

  if IOResult <> 0 then
    begin
      writeln ('Error opening ''', paramstr(1), '''...');
      halt (254);
    end;

  BlockRead (f1, pl5_data, 256, result);

  close (f1);

  assign (f2, copy(paramstr(1), 1, length (paramstr(1)) - 3) + 'INC');

  {$I-}
  rewrite (f2);
  {$I+}

  if IOResult <> 0 then
    begin
      writeln ('Error opening ''', copy(paramstr(1), 1, length (paramstr(1)) - 3), 'INC''');
      halt (253);
    end;

  writeln (f2, '; FileName: ', paramstr(1));

  for count1 := 0 to 7 do
    begin
      writeln (f2, '; Data for palette number ', count1, '...');

      write (f2, chr(9) + '.dw ');

      for count2 := 0 to 7 do
        begin
          result := pl5_data [(32 * count1) + (2 * count2)] + 256 *
                    pl5_data [(32 * count1) + (2 * count2) + 1];

          write (f2, '$' + HexWord (result));

          if count2 <> 7 then
            write (f2, ',')
          else
            writeln (f2);
        end;

      write (f2, chr(9) + '.dw ');

      for count2 := 8 to 15 do
        begin
          result := pl5_data [(32 * count1) + (2 * count2)] + 256 *
                    pl5_data [(32 * count1) + (2 * count2) + 1];

          write (f2, '$' + HexWord (result));

          if count2 <> 15 then
            write (f2, ',')
          else
            writeln (f2);
        end;

      writeln (f2);

    end;

  close (f2);

END.